server/sandbox/urls.py
from django.apps import apps
from django.conf import settings
from django.conf.urls import i18n, include
from django.contrib import admin
from django.urls import path
from django.views.static import serve
import debug_toolbar

urlpatterns = [
    path("i18n/", include(i18n)),
    path("admin/", admin.site.urls),
    path(
        "media/<path:path>",
        serve,
        {"document_root": settings.MEDIA_ROOT, "show_indexes": True},
    ),
    path("__debug__/", include(debug_toolbar.urls)),
    path(
        "",
        include(apps.get_app_config("oscar").urls[0]),  # type:ignore[attr-defined]
    ),
]

server/src/oscarbluelight/dashboard/offers/models.py
from oscar.apps.dashboard.offers.models import *  # noqa

server/src/oscarbluelight/dashboard/ranges/models.py
from oscar.apps.dashboard.ranges.models import *  # noqa

server/src/oscarbluelight/offer/models.py
from __future__ import annotations

from collections.abc import Collection, Iterable
from datetime import datetime, timedelta
from decimal import Decimal
from typing import TYPE_CHECKING, Any, Optional, TypedDict, TypeVar
import copy
import logging
import math
import time

from django.conf import settings
from django.core import exceptions
from django.db import IntegrityError, connection, models
from django.db.models import F, Q, QuerySet
from django.db.models.base import ModelBase
from django.utils import timezone
from django.utils.encoding import force_str
from django.utils.functional import cached_property
from django.utils.translation import gettext_lazy as _
from oscar.apps.offer.abstract_models import (
    AbstractBenefit,
    AbstractCondition,
    AbstractConditionalOffer,
    AbstractRange,
    AbstractRangeProduct,
    AbstractRangeProductFileUpload,
)
from oscar.apps.offer.results import ApplicationResult
from oscar.apps.offer.utils import load_proxy
from oscar.core.loading import get_class, get_model
from oscar.models.fields import AutoSlugField  # type:ignore[attr-defined]
from oscar.templatetags.currency_filters import currency
from thelabdb.pgviews import view as pg

from .results import (
    SHIPPING_DISCOUNT,
    ZERO_DISCOUNT,
    BasketDiscount,
    OfferApplication,
    PostOrderAction,
    ShippingDiscount,
)
from .sql import SQL_RANGE_PRODUCTS, get_recalculate_offer_application_totals_sql

if TYPE_CHECKING:
    from django_stubs_ext import StrOrPromise
    from oscar.apps.catalogue.expressions import ExpandDownwardsCategoryQueryset
    from oscar.apps.catalogue.models import Product
    from oscar.apps.order.models import Order as _Order
    from oscar.apps.order.models import OrderDiscount as _OrderDiscount

    from ..mixins import BluelightBasketMixin as Basket
    from ..voucher.models import Voucher as _Voucher
    from .upsells import OfferUpsell
else:
    ExpandDownwardsCategoryQueryset = get_class(
        "catalogue.expressions", "ExpandDownwardsCategoryQueryset"
    )

logger = logging.getLogger(__name__)

T = TypeVar("T", bound=type[models.Model])


def _init_proxy_class(obj: T, Klass: type[T]) -> T:
    # Check if we're already the correct class
    if obj.__class__ == Klass:  # type:ignore[comparison-overlap]
        return obj

    # Check if we're using multi-table inheritance
    model_name = Klass._meta.model_name  # type:ignore[attr-defined]
    if hasattr(obj, model_name):
        return getattr(obj, model_name)

    # Else, it's just a proxy model
    proxy = copy.deepcopy(obj)
    proxy.__class__ = Klass  # type:ignore[method-assign, assignment]
    return proxy


class AvailabilityRestriction(TypedDict):
    description: str
    is_satisfied: bool


class OfferGroup(models.Model):
    """
    Ordered group of Offers
    """

    name = models.CharField(max_length=64, null=False)
    slug = AutoSlugField(populate_from="name", unique=True, null=True, overwrite=True)
    priority = models.IntegerField(null=False, unique=True)
    is_system_group = models.BooleanField(default=False, editable=False)

    class Meta:
        verbose_name = _("OfferGroup")
        ordering = ("-priority",)

    def __str__(self) -> str:
        return "{} (priority {})".format(self.name, self.priority)


class ConditionalOffer(AbstractConditionalOffer):
    """
    groups  -- user groups
    offer_group -- FK to OfferGroup
    offerGroupA => [ o1, v2, o3 ], priority 1
    offerGroupB => [ o4, v3 ], priority 2
    To consume offers, loop through offers in offer group based on priority
    to consume OfferGroup -> only move to next (greater priority val) when previous
    offerGroup is consumed
    """

    short_name = models.CharField(
        _("Short Name"), max_length=50, help_text=_("Abbreviated version of offer name")
    )
    desktop_image = models.ImageField(
        _("Ad Image (Desktop)"),
        null=True,
        blank=True,
        upload_to=getattr(settings, "BLUELIGHT_OFFER_IMAGE_FOLDER"),
        help_text=_("Desktop image used for promo display."),
    )
    mobile_image = models.ImageField(
        _("Ad Image (Mobile)"),
        null=True,
        blank=True,
        upload_to=getattr(settings, "BLUELIGHT_OFFER_IMAGE_FOLDER"),
        help_text=_("Mobile image used for promo display."),
    )
    # When offer_type == "User", we use groups to determine which users get the offer
    groups = models.ManyToManyField(
        "auth.Group",
        verbose_name=_("User Groups"),
        blank=True,
        help_text=_(
            "Select which User Groups are eligible for this offer. If none are selected, all "
            "users are eligible."
        ),
    )
    offer_group = models.ForeignKey(
        OfferGroup,
        verbose_name=_("Offer Group"),
        related_name="offers",
        null=True,
        on_delete=models.CASCADE,
        help_text=_(
            "Select the Offer Group that this offer belongs to. Offer Group controls the order "
            "offers are applied in and which offers may be combined together."
        ),
    )
    affects_cosmetic_pricing = models.BooleanField(
        _("Affects Cosmetic Pricing?"),
        default=True,
        help_text=_(
            "Controls whether or not this offer will affect advertised product prices. Turn off "
            "for offers which should only apply once the product is in a customer's basket."
        ),
    )

    class Meta:
        ordering = ("-offer_group__priority", "-priority", "pk")

    @classmethod
    def recalculate_offer_application_totals(cls) -> None:
        Order: type["_Order"] = get_model("order", "Order")
        OrderDiscount: type["_OrderDiscount"] = get_model("order", "OrderDiscount")
        start_ns = time.perf_counter_ns()
        update_sql = get_recalculate_offer_application_totals_sql(
            Order=Order,
            OrderDiscount=OrderDiscount,
            ConditionalOffer=cls,
            ignored_order_statuses=settings.BLUELIGHT_IGNORED_ORDER_STATUSES,
        )
        with connection.cursor() as cursor:
            cursor.execute(update_sql)
            updated_rows = cursor.rowcount
        end_ns = time.perf_counter_ns()
        elasped_ms = (end_ns - start_ns) / 1_000_000
        logger.info(
            "Successfully recalculated offer application totals in %.3fms. Updated %d offers.",
            elasped_ms,
            updated_rows,
        )

    def availability_restrictions(self) -> list[AvailabilityRestriction]:
        restrictions: list[AvailabilityRestriction] = (
            super().availability_restrictions()
        )
        if self.offer_type == self.USER:
            restrictions.append(
                {
                    "description": _("Offer is limited to user groups: %s")
                    % ", ".join(g.name for g in self.groups.all()),
                    "is_satisfied": True,
                }
            )
        return restrictions

    def get_upsell_details(self, basket: Basket) -> Optional[OfferUpsell]:
        return self.condition.proxy().get_upsell_details(self, basket)

    def apply_benefit(self, basket: Basket) -> ApplicationResult:
        try:
            return super().apply_benefit(basket)
        except Exception as e:
            logger.exception(e)
            return ZERO_DISCOUNT

    def record_usage(self, discount: OfferApplication) -> None:
        ConditionalOffer.objects.filter(pk=self.pk).update(
            num_applications=(F("num_applications") + discount["freq"]),
            total_discount=(F("total_discount") + discount["discount"]),
            num_orders=(F("num_orders") + 1),
        )

    record_usage.alters_data = True  # type:ignore[attr-defined]


class Benefit(AbstractBenefit):
    # Use this field to provide an hard-cap on the discount amount than a benefit
    # can provide.
    max_discount = models.DecimalField(
        _("Max discount"),
        decimal_places=2,
        max_digits=12,
        null=True,
        blank=True,
        help_text=_(
            "If set, do not allow this benefit to provide a discount greater "
            "than this amount (for a particular basket application)."
        ),
    )

    def proxy(self) -> Benefit:
        if self.proxy_class:
            Klass = load_proxy(self.proxy_class)
            return _init_proxy_class(self, Klass)
        return super().proxy()

    @property
    def name(self) -> StrOrPromise:
        return force_str(super().name)

    @property
    def type_name(self) -> str:
        benefit_classes = getattr(settings, "BLUELIGHT_BENEFIT_CLASSES", [])
        names = dict(benefit_classes)
        names["oscarbluelight.offer.benefits.CompoundBenefit"] = _("Compound benefit")
        return names.get(self.proxy_class, self.proxy_class)

    @property
    def non_voucher_offers(self) -> QuerySet[ConditionalOffer]:
        return self.offers.exclude(offer_type=ConditionalOffer.VOUCHER).all()

    @property
    def vouchers(self) -> list[_Voucher]:
        vouchers = []
        for offer in self.offers.filter(offer_type=ConditionalOffer.VOUCHER).all():
            for voucher in offer.vouchers.filter(parent=None).all():
                vouchers.append(voucher)
        return vouchers

    def clean(self) -> None:
        if self.type:
            raise exceptions.ValidationError(
                _("Benefit should not have a type field. Use proxy class instead.")
            )
        proxy_instance = self.proxy()
        cleaner = getattr(proxy_instance, "_clean", None)
        if cleaner and callable(cleaner):
            return cleaner()
        return super().clean()

    def save(
        self,
        force_insert: bool | tuple[ModelBase, ...] = False,
        force_update: bool = False,
        using: str | None = None,
        update_fields: Iterable[str] | None = None,
    ) -> None:
        ret = super().save(
            force_insert=force_insert,
            force_update=force_update,
            using=using,

server/src/oscarbluelight/dashboard/ranges/forms.py
from decimal import Decimal
from typing import TYPE_CHECKING, Any

from django import forms
from django.contrib.postgres.search import SearchVector
from django.db.models import Q, QuerySet
from django.utils.translation import gettext_lazy as _
from oscar.apps.dashboard.ranges.forms import UPC_SET_REGEX
from oscar.apps.dashboard.ranges.forms import RangeProductForm as BaseRangeProductForm
from oscar.core.loading import get_model

from oscarbluelight.offer.models import Range, RangeProductFileUpload

if TYPE_CHECKING:
    from oscar.apps.catalogue.models import Product
else:
    Product = get_model("catalogue", "Product")


class BaseRangeSearchForm(forms.Form):
    product_name = forms.CharField(required=False, label=_("Product Name"))
    upc = forms.CharField(required=False, label=_("UPC"))
    sku = forms.CharField(required=False, label=_("SKU"))


class RangeSearchForm(BaseRangeSearchForm):
    text = forms.CharField(required=False, label=_("Search"))

    def filter_queryset(self, qs: QuerySet[Range]) -> tuple[QuerySet[Range], bool]:
        is_filtered = False
        if not self.is_valid():
            return qs, is_filtered
        data = self.cleaned_data

        if data.get("text"):
            qs = qs.annotate(search=SearchVector("name", "slug", "description")).filter(
                search=data["text"]
            )
            is_filtered = True

        # Filter by contained-products is difficult because the not a simple in-DB relationship.
        # Products are included in a range by one of several means (by category or by direct
        # inclusion) and can also be directly excluded. Thus, we can't do this filter in a single
        # query. Instead, we have to:
        #   1. Find the Products matching the query
        #   2. Build a set of all the Range IDs which include those products
        #   3. Filter the original queryset by those RangeIDs
        if data.get("product_name") or data.get("upc") or data.get("sku"):
            products_qs = Product.objects.all()
            if data.get("product_name"):
                products_qs = products_qs.filter(title__search=data["product_name"])
            if data.get("upc"):
                products_qs = products_qs.filter(upc__iexact=data["upc"])
            if data.get("sku"):
                products_qs = products_qs.filter(
                    stockrecords__partner_sku__iexact=data["sku"]
                )
            products = products_qs.all()
            range_ids = set()
            for r in qs.all():
                for p in products:
                    if r.contains_product(p):
                        range_ids.add(r.pk)
                        break
            qs = qs.filter(pk__in=range_ids)
            is_filtered = True

        return qs, is_filtered


class RangeProductSearchForm(BaseRangeSearchForm):
    pass


class BatchPriceUpdateForm(forms.Form):
    ABSOLUTE, PERCENTAGE_RETAIL, PERCENTAGE_ACTUAL = (
        "ABSOLUTE",
        "PERCENTAGE_RETAIL",
        "PERCENTAGE_ACTUAL",
    )
    TYPES = (
        (PERCENTAGE_RETAIL, "Absolute Percentage of Retail Price"),
        (PERCENTAGE_ACTUAL, "Relative Percentage of Price Excluding Tax"),
        (ABSOLUTE, "Absolute Change"),
    )
    operation_type = forms.ChoiceField(
        label="Type of Change to Apply", initial=PERCENTAGE_RETAIL, choices=TYPES
    )
    amount = forms.DecimalField(initial=0, decimal_places=2, max_digits=12)

    def __init__(
        self,
        instance: Range | None = None,
        *args: Any,
        **kwargs: Any,
    ) -> None:
        super().__init__(*args, **kwargs)

    def apply_discount(
        self,
        price_retail: Decimal,
        price_excl_tax: Decimal,
    ) -> Decimal:
        otype = self.cleaned_data["operation_type"]
        amount = self.cleaned_data["amount"]
        operations = {
            self.PERCENTAGE_RETAIL: lambda: price_retail * (amount / 100),
            self.PERCENTAGE_ACTUAL: lambda: price_excl_tax
            + (price_excl_tax * (amount / 100)),
            self.ABSOLUTE: lambda: price_excl_tax + amount,
        }
        return operations[otype]()


class RangeExcludedProductsUpdateForm(forms.ModelForm):
    class Meta:
        model = Range
        fields = ["excluded_products"]
        help_texts = {
            "excluded_products": _(
                "What is an excluded product? Products listed here will not be considered as part of this range, even "
                "if they would normally be included by another means, such as by Category, by Product Class, or because "
                "it's Parent Product is included."
            ),
        }


class RangeProductForm(BaseRangeProductForm):
    def clean_query_with_upload_type(self, raw: str, upload_type: str) -> None:
        # Check that the search matches some products
        ids = set(UPC_SET_REGEX.findall(raw))
        # switch for included or excluded products
        if upload_type == RangeProductFileUpload.EXCLUDED_PRODUCTS_TYPE:
            products = self.product_range.excluded_products.all()
            action = _("excluded from this range")
        else:
            # Fetch the product queryset directly from the database to make the
            # success/warning/error messages be consistent with the dashboard view
            products = self.product_range.all_products_consistent()
            action = _("added to this range")
        existing_skus = set(
            products.values_list("stockrecords__partner_sku", flat=True)
        )
        existing_upcs = set(products.values_list("upc", flat=True))
        existing_ids = existing_skus.union(existing_upcs)
        new_ids = ids - existing_ids
        if len(new_ids) == 0:
            self.add_error(
                "query",
                _(
                    "The products with SKUs or UPCs matching %(skus)s have "
                    "already been %(action)s"
                )
                % {"skus": ", ".join(ids), "action": action},
            )
        else:
            self.products = Product._default_manager.filter(
                Q(stockrecords__partner_sku__in=new_ids) | Q(upc__in=new_ids)
            )
            if len(self.products) == 0:
                self.add_error(
                    "query",
                    _("No products exist with a SKU or UPC matching %s")
                    % ", ".join(ids),
                )
            found_skus = set(
                self.products.values_list("stockrecords__partner_sku", flat=True)
            )
            found_upcs = set(self.products.values_list("upc", flat=True))
            found_ids = found_skus.union(found_upcs)
            self.missing_skus = new_ids - found_ids
            self.duplicate_skus = existing_ids.intersection(ids)

server/src/oscarbluelight/templates/oscar/dashboard/ranges/range_excluded_products.html
{% extends 'oscar/dashboard/layout.html' %}
{% load i18n %}

{% block title %}
    {% trans "Excluded Products" %} | {{ block.super }}
{% endblock %}

{% block breadcrumbs %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:index' %}">{% trans "Dashboard" %}</a>
            </li>
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:range-list' %}">{% trans "Ranges" %}</a>
            </li>
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:range-update' pk=range.pk %}">{{ range.name }}</a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                {% trans "Excluded Products" %}
            </li>
        </ol>
    </nav>
{% endblock %}


{% block header %}
    <div class="page-header">
        <h1>{% blocktrans with name=range.name %}Edit Products Excluded From {{ name }}{% endblocktrans %}</h1>
    </div>
{% endblock header %}


{% block dashboard_content %}
    <div class="table-header">
        <h3><i class="fas fa-edit"></i> {% trans "Edit" %}</h3>
    </div>
    <form method="post" class="form-stacked card card-body bg-light wysiwyg">
        {% csrf_token %}
        {% include "oscar/dashboard/partials/form_fields.html" with form=form %}
        {% block form_actions %}
            <div class="form-actions">
                <button class="btn btn-primary" type="submit" data-loading-text="{% trans 'Saving...' %}">{% trans "Save" %}</button>
                {% trans "or" %}
                <a href="{% url 'dashboard:range-list' %}">{% trans "cancel" %}</a>
            </div>
        {% endblock form_actions %}
    </form>
{% endblock dashboard_content %}

server/src/oscarbluelight/templates/oscar/dashboard/ranges/range_list.html
{% extends 'oscar/dashboard/ranges/range_list.html' %}
{% load i18n %}

{% block dashboard_content %}
    <table class="table table-striped table-bordered">
        <caption><i class="fas fa-grip-vertical"></i> {% trans "Ranges" %}</caption>
        {% if ranges %}
            <thead>
                <tr>
                    <th>{% trans "Name" %}</th>
                    <th>{% trans "Num products" %}</th>
                    <th>{% trans "Is public?" %}</th>
                    <th>{% trans "Dependents" %}</th>
                    <th>{% trans "Date created" %}</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                {% for range in ranges %}
                    <tr>
                        <td>
                            {% if range.is_editable %}
                                <a href="{% url 'dashboard:range-update' pk=range.id %}">{{ range.name }}</a>
                            {% else %}
                                {{ range.name }}
                            {% endif %}
                        </td>
                        {% if range.includes_all_products %}
                            <td>{% trans 'All' %}</td>
                        {% else %}
                            <td>{{ range.num_products|default:"-" }}</td>
                        {% endif %}
                        {% if range.is_public %}
                            <td>{% trans "Yes" %}</td>
                        {% else %}
                            <td>{% trans "No" %}</td>
                        {% endif %}
                        <td>
                            {% if range.benefit_set.exists %}
                                <em>{% trans "Benefits" %}</em>
                                <ul>
                                    {% for benefit in range.benefit_set.all %}
                                        <li><a href="{% url 'dashboard:benefit-update' pk=benefit.pk %}">{{ benefit.name }}</a></li>
                                    {% endfor %}
                                </ul>
                            {% endif %}
                            {% if range.condition_set.exists %}
                                <em>{% trans "Conditions" %}</em>
                                <ul>
                                    {% for condition in range.condition_set.all %}
                                        <li><a href="{% url 'dashboard:condition-update' pk=condition.pk %}">{{ condition.name }}</a></li>
                                    {% endfor %}
                                </ul>
                            {% endif %}
                            {% if not range.benefit_set.exists and not range.condition_set.exists %}
                                <em>{% trans "None" %}</em>
                            {% endif %}
                        </td>
                        <td>{{ range.date_created }}</td>
                        <td>
                            <div class="btn-toolbar">
                                <div class="dropdown">
                                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        {% trans "Actions" %}
                                    </button>
                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="dropdownMenuButton">
                                        {% if range.is_editable %}
                                            <a class="dropdown-item" href="{% url 'dashboard:range-update' pk=range.id %}">{% trans "Edit" %}</a>
                                            {% if not range.includes_all_products %}
                                                <a class="dropdown-item" href="{% url 'dashboard:range-products' pk=range.id %}">{% trans "Edit products" %}</a>
                                            {% endif %}
                                        {% endif %}
                                        {% if range.is_public %}
                                            <a class="dropdown-item" href="{{ range.get_absolute_url }}">{% trans "View on site" %}</a>
                                        {% endif %}

                                        {% if range.benefit_set.exists or range.condition_set.exists %}
                                            <a class="dropdown-item" href="#" title="{% trans 'Can not delete a product with a dependent condition or benefit.' %}">{% trans "Delete" %}</a>
                                        {% else %}
                                            <a class="dropdown-item" href="{% url 'dashboard:range-delete' pk=range.id %}">{% trans "Delete" %}</a>
                                        {% endif %}
                                    </div>
                                </div>
                            </div>
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        {% else %}
            <tr><td>{% trans "No ranges found." %}</td></tr>
        {% endif %}
    </table>
    {% include "oscar/dashboard/partials/pagination.html" %}
{% endblock dashboard_content %}